--@todo swap in stealth
local DEG_ADDON = _G["DEG_CURRENT_ADDON"]

local function d(...)
  _G[DEG_ADDON.PACKAGE_NAME].plugins[DEG_ADDON.ADDON_NAME_SHORT]:d(...)
end

local function deglib(libSafe, libname, ...)
  if not _G[DEG_ADDON.PACKAGE_NAME].libs then return end
  if not _G[DEG_ADDON.PACKAGE_NAME].libs[libname] then return end
  libSafe:makeTableSafe(_G[DEG_ADDON.PACKAGE_NAME].libs[libname])
  return _G[DEG_ADDON.PACKAGE_NAME].libs[libname]:initialize(...)
end

local function ts(...)
  return tostring(...)
end

local function getIdFromLink(itemLink)
    local split = {SplitString(':', itemLink)}
    if split[3] then 
      return tonumber(split[3])    
    end
end

local function getItemLink(itemId)
  return "|H0:item:"..itemId..":1:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
end

local Addon = {}
Addon.initialized = false
Addon.debug = false--release:false
Addon.name = DEG_ADDON.ADDON_NAME
Addon.versionString = '1.045'
Addon.saveVariablesName = DEG_ADDON.SAVED_VARS_NAME
Addon.saveVariablesVersion = 9
Addon.savedVariablesAccount = nil
Addon.savedVariablesChar = nil
Addon.vars = {
  [ItemTooltip] = {link = nil, linkIsNew = nil},
  [PopupTooltip] = {link = nil, linkIsNew = nil},
  [ComparativeTooltip1] = {link = nil, linkIsNew = nil},
  [ComparativeTooltip2] = {link = nil, linkIsNew = nil},
  gearOperations = {},
  operations = {
    unequip = 1,
  },
  bagFrom = nil,
  slotFrom = nil,
  equipSlots = {
    EQUIP_SLOT_CHEST,
    EQUIP_SLOT_FEET,
    EQUIP_SLOT_HAND,
    EQUIP_SLOT_HEAD,
    EQUIP_SLOT_LEGS,
    EQUIP_SLOT_NECK,
    EQUIP_SLOT_RING1,
    EQUIP_SLOT_RING2,
    EQUIP_SLOT_SHOULDERS,
    EQUIP_SLOT_WAIST,
  }
  
----EQUIP_SLOT_CHEST
--2--  2
----EQUIP_SLOT_FEET
--9--  9
----EQUIP_SLOT_HAND
--16--  16
----EQUIP_SLOT_HEAD
--0--  0  
----EQUIP_SLOT_LEGS
--8--  8
----EQUIP_SLOT_NECK
--1--  1
----EQUIP_SLOT_RING1
--11--  11
----EQUIP_SLOT_RING2
--12--  12
----EQUIP_SLOT_SHOULDERS
--3--  3
----EQUIP_SLOT_WAIST
--6 --  6
  
  
}
Addon.Settings = _G[DEG_ADDON.ADDON_NAME.."Settings"]

function Addon:Initialize()
  if (self.initialized) then return end
  
  SLASH_COMMANDS["/undress"] = function()
    d("undressAll")  
    local async = LibStub("LibAsync")
    local taskUndress = async:Create("DEGSetzUndress")    
    
    self.vars.gearOperations = {}  
    for i,es in pairs(self.vars.equipSlots) do         
      local itemId = GetItemId(BAG_WORN, es)
      if itemId and itemId ~= 0 then
        table.insert(self.vars.gearOperations, {
          op = self.vars.operations.unequip,
          es = es,
        })
      end
    end    
    self:performGearOperations()
  end
  
  self.libSafe = LibStub("LibSafe").new(self, self.name, self.saveVariablesName, self.debug)  
  self.libSafe:makeTableSafe() 
  self.libSafe:makeTableSafe(self.Settings)
 
  local saveVariablesVersion = self.saveVariablesVersion
  if self.debug then
    --math.randomseed(os.clock()*100000000000)
    saveVariablesVersion = math.random(10000, 65000)
  end
 
  local defaultsAccount = {sets={},slots={},settings={levelDist=10}}
  self.savedVariablesAccount = ZO_SavedVars:NewAccountWide(self.saveVariablesName, saveVariablesVersion, nil, defaultsAccount)
    
  local defaultsChar = {gears={},settings={gearSwap=false,levelDist=false,wield=true,swords2=true,bigsword=true,damagestaff=true,healingstaff=true,bow=true}}
  self.savedVariablesChar = ZO_SavedVars:New(self.saveVariablesName, saveVariablesVersion, nil, defaultsChar)  
  
  self.Settings:initialize()
  
  --self.debug = false
  if self.debug then
    for k,v in pairs(defaultsAccount) do
      self.savedVariablesAccount[k] = v
    end
    for k,v in pairs(defaultsChar) do
      self.savedVariablesChar[k] = v
    end    
  end

  local moreMotd = ""
  if self.debug then moreMotd =" ,"..ts(GetGameTimeMilliseconds()) end   
  LibStub("LibMOTD"):setMessage(self.saveVariablesName, "|c3f95ffDryzler's|r |cEFEBBESetz|r: "..GetString(SI_DEG_SETZ_MOTD)..moreMotd, 1)
    
  local LibChars = LibStub("LibChars")       
  LibChars:initialize(self.savedVariablesAccount, nil, nil,
    function(charId, char)
      d("fnCharRemoved "..ts(charId).." "..ts(char)) 
      --fnCharRemoved
      local sourceInv = charId
      self.savedVariablesAccount.slots[sourceInv] = nil
      for setName,tblSet in pairs(self.savedVariablesAccount.sets) do
        tblSet.items[sourceInv] = nil
      end
    end
  )
 
  EVENT_MANAGER:RegisterForEvent(self.name, EVENT_INVENTORY_SINGLE_SLOT_UPDATE, function(...) self:onEVENT_INVENTORY_SINGLE_SLOT_UPDATE(...) end)
  EVENT_MANAGER:AddFilterForEvent(self.name, EVENT_INVENTORY_SINGLE_SLOT_UPDATE, REGISTER_FILTER_INVENTORY_UPDATE_REASON, INVENTORY_UPDATE_REASON_DEFAULT) 
     
  EVENT_MANAGER:RegisterForEvent(self.name, EVENT_ACTION_SLOTS_FULL_UPDATE, function(...) self:onEVENT_ACTION_SLOTS_FULL_UPDATE(...) end)
  EVENT_MANAGER:RegisterForEvent(self.name, EVENT_ACTIVE_WEAPON_PAIR_CHANGED, function(...) self:onEVENT_ACTIVE_WEAPON_PAIR_CHANGED(...) end)

  local deglibtt = deglib(self.libSafe, "tooltip")
  local tt = deglibtt:new(function(Tooltip, itemLink)
    self:paintTooltip(Tooltip, itemLink)
  end)
               
  EVENT_MANAGER:RegisterForEvent(self.name, EVENT_PLAYER_ACTIVATED, function(...) self:onEVENT_PLAYER_ACTIVATED(...) end)
   
  self.initialized = true
end

function Addon:performGearOperations()
  if #self.vars.gearOperations > 0 then
    local op = table.remove(self.vars.gearOperations, 1)
    if op.op == self.vars.operations.unequip then
      UnequipItem(op.es)
    elseif op.op == self.vars.operations.equip then
      EquipItem(op.bagId, op.slotId, op.es)
    end
  end
end

----------------- TOOLTIP ---------------------------------------

function Addon:paintTooltip(Tooltip, itemLink)
  local hasSet, setName, numBonuses, numEquipped, maxEquipped = GetItemLinkSetInfo(itemLink)
  
  if not hasSet then return end  
  
  local r, g, b = ZO_TOOLTIP_DEFAULT_COLOR:UnpackRGB()
  
  local numAvailable = 0
  local numAvailableComplete = 0
  local numWorn = numEquipped
  local numWornOther = 0
  local numMax = maxEquipped
  
  if self.savedVariablesAccount.sets[setName] then
    
    numAvailable = self.savedVariablesAccount.sets[setName].numAvailable
    numAvailableComplete = self.savedVariablesAccount.sets[setName].numAvailableComplete    
    numWornOther = self.savedVariablesAccount.sets[setName].numWornOther
        
  end

  local partWorn = string.format("%u", numWorn)
  local partWornString = GetString(DEG_SETZ_WORN)  
  if numWorn ~= numWornOther then
    --numWornOtherWearSet nur wenn überhaupt 2tes set verfügbar und etwas ausgerüstet so dass man switchen könnte / es vorhat
    --local bagSize = GetBagSize(BAG_WORN)       
    --for slotId = 0, bagSize, 1 do
      --local icon, slotHasItem, sellPrice, isHeldSlot, isHeldNow, locked = GetEquippedItemInfo(slotId)
      --if slotHasItem and isHeldSlot and not isHeldNow then
        partWorn = string.format("%i(%i)", numWorn, numWornOther)  
        --break
      --end
    --end
  end
  
  local partAvailable = string.format("%i", numAvailable)
  local partAvailableString = GetString(DEG_SETZ_WORN_AVAILABLE_UNIQUE)
  if numAvailable ~= numAvailableComplete then  
    partAvailable = string.format("%i(%i)", numAvailable, numAvailableComplete)
  end
  
  local partMax = string.format("%i", numMax) 
  
  ZO_Tooltip_AddDivider(Tooltip)
      
  --Set Info: worn 5(6), max 5, available 6(8)
  local text = string.format("Set Info: "
    ..partWornString..": |cFFFFFF"..partWorn.."|r"
    .." / max: ".."|cFFFFFF"..partMax.."|r"
    .." / "..partAvailableString..": |cFFFFFF"..partAvailable.."|r")    
  
  Tooltip:AddLine(text, "$(MEDIUM_FONT)|$(KB_16)|soft-shadow-thin", r, g, b, LEFT, MODIFY_TEXT_TYPE_NONE, TEXT_ALIGN_CENTER, false)
end

----------------- INVENTOR / SETS ---------------------------------------

function Addon:parseSets()    
  local async = LibStub("LibAsync")
  local task = async:Create("DEGSetzParseSets")
     
  task:Call(function()
    for setName,v in pairs(self.savedVariablesAccount.sets) do
      self:parseSet(setName)
    end
  end)
end

function Addon:parseSet(setName)
  if not self.savedVariablesAccount.sets[setName] then
    self.savedVariablesAccount.sets[setName] = {}
    self.savedVariablesAccount.sets[setName].setName = setName
  end  
  
  self.savedVariablesAccount.sets[setName].numAvailable = 0
  self.savedVariablesAccount.sets[setName].numAvailableComplete = 0  
  self.savedVariablesAccount.sets[setName].numWorn = 0
  self.savedVariablesAccount.sets[setName].numWornOther = 0
  
  local availableItems = {}
  
  --local availableItemsWorn = {}
  --local availableItemsWornOther = {}
    
  local numAvailable = 0;
  local numAvailableComplete = 0;  
  local numWorn = 0;
  local numWornOther = 0;
  local numOtherWeaponPair = 0;
    
  local playerLevel = GetUnitLevel("player")
  local playerChampionPoints = GetUnitChampionPoints("player")  
  local playerLevelEff = playerLevel + playerChampionPoints
  
  if playerLevelEff > (50 + 160) then
    playerLevelEff = 50 + 160
  end    
    
  local hasSword = false
  local mainHandOccupied = false
  local secondHandOccupied = false
  
  for sourceInv, tblBags in pairs(self.savedVariablesAccount.sets[setName].items) do
    for bagId, tblSlots in pairs(tblBags) do
      local itemsToRemove = {}
      for slotId, boolVal in pairs(tblSlots) do
      
        local item = self.savedVariablesAccount.slots[sourceInv][bagId][slotId]
    
        if not item then
          itemsToRemove[slotId] = true
        elseif item.setName ~= setName then
          itemsToRemove[slotId] = true    
        else
          local doCount = false
        
          numAvailableComplete = numAvailableComplete + 1
                    
          local _icon, _sellPrice, _meetsUsageRequirement, _equipType, _itemStyle = GetItemLinkInfo(item.itemLink)
          local itemLevel = GetItemLinkRequiredLevel(item.itemLink)
          local itemChampionPoints = GetItemLinkRequiredChampionPoints(item.itemLink)
          
          local itemLevelEff = itemLevel + itemChampionPoints
                
          if not _meetsUsageRequirement then

          else
            if self.savedVariablesChar.settings.levelDist or self.savedVariablesChar.settings.levelDist == 0 then
              local minItemLevel = playerLevelEff - self.savedVariablesChar.settings.levelDist
              if itemLevelEff < minItemLevel then

              else
                --count
                doCount = true
              end
            elseif self.savedVariablesAccount.settings.levelDist or self.savedVariablesAccount.settings.levelDist == 0 then
              local minItemLevel = playerLevelEff - self.savedVariablesAccount.settings.levelDist
              if itemLevelEff < minItemLevel then

              else
                --count
                doCount = true
              end
            else
              doCount = true
            end
          end
          
          if doCount then
            local doCount2 = false
            --local specializedItemTypeArmor, specializedItemTypeWeapon = GetItemLinkArmorType(itemLink), GetItemLinkWeaponType(itemLink)
            local specializedItemTypeWeapon = GetItemLinkWeaponType(item.itemLink)
            
            local isMainHand = false
            local isSecondHand = false
                        
            if (  specializedItemTypeWeapon == WEAPONTYPE_SWORD 
               or specializedItemTypeWeapon == WEAPONTYPE_HAMMER
               or specializedItemTypeWeapon == WEAPONTYPE_DAGGER
               or specializedItemTypeWeapon == WEAPONTYPE_AXE
            ) then
              --schwert mit schild oder 2 waffen (überhaupt) aktiviert?
              if self.savedVariablesChar.settings.wield or self.savedVariablesChar.settings.swords2 then
                if hasSword then
                  --wenn es schon ein schwert gibt, dann ist es isSecondHand
                  isSecondHand = true
                else
                  hasSword = true
                  isMainHand = true
                end
              end
            elseif (specializedItemTypeWeapon == WEAPONTYPE_SHIELD) then
              --schild
              if self.savedVariablesChar.settings.wield then
                --wird durch isMainHand und isSecondHand geregelt
                isSecondHand = true
              end              
            elseif (  specializedItemTypeWeapon == WEAPONTYPE_TWO_HANDED_AXE
                   or specializedItemTypeWeapon == WEAPONTYPE_TWO_HANDED_HAMMER
                   or specializedItemTypeWeapon == WEAPONTYPE_TWO_HANDED_SWORD                            
            ) then
              --2 hand waffe
              if self.savedVariablesChar.settings.bigsword then
                isMainHand = true
              end            
            elseif (  specializedItemTypeWeapon == WEAPONTYPE_LIGHTNING_STAFF
                   or specializedItemTypeWeapon == WEAPONTYPE_FROST_STAFF
                   or specializedItemTypeWeapon == WEAPONTYPE_FIRE_STAFF
            ) then                   
              --zerstörungsstab
              if self.savedVariablesChar.settings.damagestaff then
                isMainHand = true
              end            
              
            elseif (  specializedItemTypeWeapon == WEAPONTYPE_HEALING_STAFF
            ) then                   
              --heilungsstab
              if self.savedVariablesChar.settings.healingstaff then
                isMainHand = true
              end              
              
            elseif (  specializedItemTypeWeapon == WEAPONTYPE_BOW
            ) then                   
              --bogen
              if self.savedVariablesChar.settings.bow then
                isMainHand = true
              end
            else
              --irgendwas anderes
              --local itemType, specializedItemType = GetItemLinkItemType(itemLink)
              --itemType == ITEMTYPE_ARMOR or itemType == ITEMTYPE_WEAPON then
              
              local _, _, _, specializedItemTypeEquip = GetItemLinkInfo(item.itemLink)
              if not availableItems[specializedItemTypeEquip] then
                availableItems[specializedItemTypeEquip] = true
                numAvailable = numAvailable + 1
                doCount2 = true
              else
                --ringe gibt es 2mal
                --ahhh, aber nur wenn auch ringe...!
                if specializedItemTypeEquip == EQUIP_TYPE_RING then
                  local specializedItemTypeEquip2cnd = specializedItemTypeEquip..'2cnd'
                  if not availableItems[specializedItemTypeEquip2cnd] then
                    availableItems[specializedItemTypeEquip2cnd] = true
                    numAvailable = numAvailable + 1
                    doCount2 = true
                  end                
                end
              end              
            end
            
            if isMainHand then --@todo isMainHand = false wenn option deaktiviert
              if not mainHandOccupied then
                numAvailable = numAvailable + 1
                doCount2 = true
              end
              mainHandOccupied = true
            end

            if isSecondHand then
              if not secondHandOccupied then
                numAvailable = numAvailable + 1
                doCount2 = true
              end
            end
    
            if bagId == BAG_WORN and sourceInv == GetCurrentCharacterId() then
              --alles was angezogen ist, auch im anderen waffenset, zählen als ausgerüstet            
              local icon, slotHasItem, sellPrice, isHeldSlot, isHeldNow, locked = GetEquippedItemInfo(slotId)
              if slotHasItem then
                if isHeldSlot then
                  --wechselbarer slot
                  if isHeldNow then
                    --aktuelles waffenset
                    numWorn = numWorn + 1                      
                  else
                    --anderes waffenset
                    numWornOther =  numWornOther + 1
                    numOtherWeaponPair = numOtherWeaponPair + 1
                  end
                else
                  --fester slot
                  numWorn = numWorn + 1
                  numWornOther = numWornOther + 1                    
                end
              end
            end
          end
        end    
      end      
      for slotId,v in pairs(itemsToRemove) do
        self.savedVariablesAccount.sets[setName].items[sourceInv][bagId][slotId] = nil
      end
    end
  end

  --num worn zeigt den richtigen status für das aktuelle weaponpair an
  --wenn gear swap aktiviert ist, muss wornOther anderst ermittelt werden
  if self.savedVariablesChar.settings.gearSwap then
    local weaponPair, boolean_locked = GetActiveWeaponPairInfo()
    if weaponPair == 1 then weaponPair = 2 else weaponPair = 1 end
    if not self.savedVariablesChar.gears[weaponPair] then
      --das andere waffenset ist noch nicht gespeichert, also gilt die gleiche ausrüstung und das ermittele numWornOther ist korrekt
    else
      numWornOther = 0
      for es,tbl in pairs(self.savedVariablesChar.gears[weaponPair].slots) do
        --hierbei geht es aber nur um ausrüstungsgegenstände, nicht um waffen        
        if tbl.itemId and tbl.itemId ~= 0 then
          --es ist ein item, ist das item von diesem set?
          --local itemName = GetItemName(bagId, slotId)
          local itemLink = GetItemLink(tbl.bagId, tbl.slotId)
          --local itemType, specializedItemType = GetItemLinkItemType(itemLink)     
          local hasSet, setName2, numBonuses, numEquipped, maxEquipped = GetItemLinkSetInfo(itemLink)
          if setName2 == setName then
            numWornOther = numWornOther + 1
          end                     
        end
      end
      --also müssen die waffen des anderen waffensets auch nochmal hinzugefügt werden
      numWornOther = numWornOther + numOtherWeaponPair
    end        
  end

  self.savedVariablesAccount.sets[setName].numAvailable = numAvailable
  self.savedVariablesAccount.sets[setName].numAvailableComplete = numAvailableComplete
  self.savedVariablesAccount.sets[setName].numWorn = numWorn
  self.savedVariablesAccount.sets[setName].numWornOther = numWornOther  

end

function Addon:handleSlot(bagId, slotId, source, SetInfo, isNewItem, itemSoundCategory, inventoryUpdateReason, stackCountChange)
  --source="parseInventories" || "slotUpdate"
  
  if bagId ~= BAG_BACKPACK  and bagId ~= BAG_WORN and bagId ~= BAG_BANK and bagId ~= BAG_SUBSCRIBER_BANK then return end

  local sourceInv = GetCurrentCharacterId()
  if bagId == BAG_BANK then sourceInv = "Bank" end
  if bagId == BAG_SUBSCRIBER_BANK then sourceInv = "BankSubscriber" end
  
  local itemName = GetItemName(bagId, slotId)
  local itemLink = GetItemLink(bagId, slotId)
  local itemType, specializedItemType = GetItemLinkItemType(itemLink)     
  local hasSet, setName, numBonuses, numEquipped, maxEquipped = GetItemLinkSetInfo(itemLink)  
  local isItem = true
  if not itemName or itemName == "" then
    isItem = false 
  end  
   
  if isItem then  
     if hasSet then
          
--       d("handleSetItem:"
--       .." bagId="..bagId
--       .." slotId="..slotId
--       .." itemName="..tostring(itemName)
--       .." hasSet="..tostring(hasSet)
--       .." setName="..tostring(setName)
--       .." numBonuses="..tostring(numBonuses)
--       .." numEquipped="..tostring(numEquipped)
--       .." maxEquipped="..tostring(maxEquipped)
--       )
       
       self:addSetItem(sourceInv, bagId, slotId, {
          itemId = getIdFromLink(itemLink),
          itemLink = itemLink,    
          setName = setName,        
       })
      return setName
    else
      --item ist kein set
      self:removeItem(sourceInv, bagId, slotId)          
    end
  else
    --item ist kein item
    self:removeItem(sourceInv, bagId, slotId)
  end
  
  if bagId == BAG_WORN then
    
  end
end
  
function Addon:addSetItem(sourceInv, bagId, slotId, SetInfo) 
  if not self.savedVariablesAccount.slots[sourceInv] then
    self.savedVariablesAccount.slots[sourceInv] = {}
  end
  
  if not self.savedVariablesAccount.slots[sourceInv][bagId] then
    self.savedVariablesAccount.slots[sourceInv][bagId] = {}
  end
  
  --1)slot setzen
  self.savedVariablesAccount.slots[sourceInv][bagId][slotId] = SetInfo
  
  --2)set aktualisieren
  if not self.savedVariablesAccount.sets[SetInfo.setName] then
    self.savedVariablesAccount.sets[SetInfo.setName] = {
      items= {},
    }
  end
  
  if not self.savedVariablesAccount.sets[SetInfo.setName].items[sourceInv] then
    self.savedVariablesAccount.sets[SetInfo.setName].items[sourceInv] = {}
  end 
  if not self.savedVariablesAccount.sets[SetInfo.setName].items[sourceInv][bagId] then
    self.savedVariablesAccount.sets[SetInfo.setName].items[sourceInv][bagId] = {}
  end
  self.savedVariablesAccount.sets[SetInfo.setName].items[sourceInv][bagId][slotId] = true
  
  --update set stats
  self:parseSet(SetInfo.setName)
end
  
function Addon:removeItem(sourceInv, bagId, slotId)
  if self.savedVariablesAccount.slots[sourceInv] then
    if self.savedVariablesAccount.slots[sourceInv][bagId] then
      if self.savedVariablesAccount.slots[sourceInv][bagId][slotId] then
        
        --1)set aktualisieren
        local SetInfo = self.savedVariablesAccount.slots[sourceInv][bagId][slotId]
        
        if self.savedVariablesAccount.sets[SetInfo.setName] then
          if self.savedVariablesAccount.sets[SetInfo.setName].items then
            if self.savedVariablesAccount.sets[SetInfo.setName].items[sourceInv] then
              if self.savedVariablesAccount.sets[SetInfo.setName].items[sourceInv][bagId] then
                if self.savedVariablesAccount.sets[SetInfo.setName].items[sourceInv][bagId][slotId] then
                  --item war vorher ein set
                  self.savedVariablesAccount.sets[SetInfo.setName].items[sourceInv][bagId][slotId] = nil
                  self:parseSet(SetInfo.setName)
                end
              end
            end
          end
        end
      end
    end
  end
end

function Addon:parseInventories()  
  local BagList = {BAG_WORN, BAG_BACKPACK, BAG_BANK, BAG_SUBSCRIBER_BANK}
    
  local async = LibStub("LibAsync")
  local task = async:Create("DEGSetzParseInventory")
     
  local sets = {}
  local numBags = 0
  
  for idx, bagId in ipairs(BagList) do     
    task:Call(function()
      local bagSize = GetBagSize(bagId)    
      --d("bagSize("..bagId..")=" .. bagSize)   
      for slotId = 0, bagSize, 1 do
        local set = self:handleSlot(bagId, slotId, "parseInventories")
        if set then
          sets[set] = true
        end
      end
      numBags = numBags + 1
      if numBags == 4 then
        for set,v in pairs(sets) do
          self:parseSet(set)
        end      
      end
    end)    
  end
end

function Addon:parseWorn()
  local sets = {}
  local bagSize = GetBagSize(BAG_WORN)       
  for slotId = 0, bagSize, 1 do
    local itemName = GetItemName(BAG_WORN, slotId)
    if not itemName or itemName == "" then else
      local itemLink = GetItemLink(BAG_WORN, slotId)
      local hasSet, setName, numBonuses, numEquipped, maxEquipped = GetItemLinkSetInfo(itemLink)
      if hasSet then
        sets[setName] = true
      end
    end    
  end
  
  for k,v in pairs(sets) do
    self:parseSet(k)
  end
end

--------------------------------------------------------------------------------------------------------------------

function Addon:onEVENT_ACTION_SLOTS_FULL_UPDATE(isHotbarSwap)
  --if not isHotbarSwap then return end
  --d("onEVENT_ACTION_SLOTS_FULL_UPDATE: isHotbarSwap")         
end


function Addon:saveGear()
  local activeWeaponPair, boolean_locked = GetActiveWeaponPairInfo()
  
  --d("saveGear activeWeaponPair="..ts(activeWeaponPair).." locked="..ts(boolean_locked))
    
  if not self.savedVariablesChar.gears[activeWeaponPair] then
    self.savedVariablesChar.gears[activeWeaponPair] =  { 
      slots= {}
    }
  end
    
  for i,es in pairs(self.vars.equipSlots) do   
    local itemId = GetItemId(BAG_WORN, es)
    --d("saving slot "..ts(es).." with item "..ts(itemId))
    self.savedVariablesChar.gears[activeWeaponPair].slots[es] = {
      itemId = itemId,
      bagId = BAG_WORN,
      slotId = es
    }
  end
end

--function Addon:uneqipAndequip()
--  local activeWeaponPair, boolean_locked = GetActiveWeaponPairInfo()
--  if #self.vars.isUnEquippingItem > 0 then
--    local es = self.vars.isUnEquippingItem[1]
--    UnequipItem(es)
--  elseif #self.vars.isEquippingItem > 0 then
--    local es = self.vars.isEquippingItem[1]
--    local bagId = self.savedVariablesChar.gears[activeWeaponPair].slots[es].bagId
--    local slotId = self.savedVariablesChar.gears[activeWeaponPair].slots[es].slotId
--    EquipItem(bagId, slotId, es)  
--  end
--end

function Addon:onEVENT_ACTIVE_WEAPON_PAIR_CHANGED(eventCode, activeWeaponPair, locked)
  --d("onEVENT_ACTIVE_WEAPON_PAIR_CHANGED activeWeaponPair="..ts(activeWeaponPair).. " locked="..ts(locked))
    
  if activeWeaponPair == 0 then return end
     
  if not self.savedVariablesChar.gears[activeWeaponPair] then
    --d("speichere das aktuell angelegte, weil noch nicht gespeichert")
    self:saveGear()
    self:parseWorn()
    return
  end
    
  --das gespeicherte set anlegen
  
  if self.savedVariablesChar.settings.gearSwap then
    --lege das andere (gespeicherte) gear an
    
    local activeWeaponPairBefore = 1
    if activeWeaponPair == 1 then
      activeWeaponPairBefore = 2
    end
    
    for es,tbl in pairs(self.savedVariablesChar.gears[activeWeaponPair].slots) do
      if tbl.itemId and tbl.itemId ~= 0 then
        --der slot hat ein item, wenn ein anderes ausgerüstet, dann ersetzen
        --nur ausrüsten wenn das zielitem nicht das gleiche ist
        local otherItemId = GetItemId(BAG_WORN, es)
        if otherItemId ~= tbl.itemId then
          --zuerst ausziehen? oder gleich anziehen?
          table.insert(self.vars.gearOperations, {
            op = self.vars.operations.equip,
            es = es,
            bagId = tbl.bagId,
            slotId = tbl.slotId
          })                    
        end
      else
        --nur UnequipItem wenn etwas ausgerüstet
        local itemId = GetItemId(BAG_WORN, es)
        if itemId and itemId ~= 0 then
          table.insert(self.vars.gearOperations, {
            op = self.vars.operations.unequip,
            es = es,
          })                            
        end
      end
    end
    
    self:performGearOperations()        
  end  
end

function Addon:onEVENT_INVENTORY_SINGLE_SLOT_UPDATE(eventCode, bagId, slotId, isNewItem, itemSoundCategory, inventoryUpdateReason, stackCountChange)
  local itemId = GetItemId(bagId, slotId)
  
  d("onEVENT_INVENTORY_SINGLE_SLOT_UPDATE item="..ts(itemId).. " bag="..ts(bagId).." slotId="..ts(slotId).." isNewItem="..ts(isNewItem).." inventoryUpdateReason="..ts(inventoryUpdateReason))
  
  self:handleSlot(bagId, slotId, "slotUpdate", isNewItem, itemSoundCategory, inventoryUpdateReason, stackCountChange)
  
  if self.vars.bagFrom == nil then
    --start transaction
    self.vars.bagFrom = bagId
    self.vars.slotFrom = slotId
    if bagId == BAG_WORN then
      --es wurde etwas ausgezogen
      self.vars.esFrom = slotId
    else
      --es wurde nichts ausgezogen
      self.vars.esFrom = nil      
    end    
  else
    --end transaction
    if self.vars.bagFrom == BAG_WORN then
      d("es wurde etwas ausgezogen")
      --problem: wenn der es slot im anderen waffenset das gleiche item hat
      --muss die neue location des items im anderen weaponset gespeichert werden
      local weaponPair, boolean_locked = GetActiveWeaponPairInfo()
      if weaponPair == 1 then weaponPair = 2 else weaponPair = 1 end
    
      if self.savedVariablesChar.gears[weaponPair] then
        if self.savedVariablesChar.gears[weaponPair].slots[self.vars.esFrom] then
          if self.savedVariablesChar.gears[weaponPair].slots[self.vars.esFrom].itemId == itemId then
            self.savedVariablesChar.gears[weaponPair].slots[self.vars.esFrom].bagId = bagId
            self.savedVariablesChar.gears[weaponPair].slots[self.vars.esFrom].slotId = slotId
          end
        end
      end
      
      if #self.vars.gearOperations == 0 then
        self:saveGear()
        self:parseWorn()
      end
      
      
    elseif bagId == BAG_WORN then
      d("es wurde etwas angezogen")
      local weaponPair, boolean_locked = GetActiveWeaponPairInfo()
      if self.savedVariablesChar.gears[weaponPair] then
        self.savedVariablesChar.gears[weaponPair].slots[slotId] = {
          itemId = itemId,
          bagId = bagId,
          slotId = slotId,
          es = slotId,
        }       
      end
                  
      if #self.vars.gearOperations == 0 then
        self:saveGear();
        self:parseWorn()
      end      
    else 
      d("die transaktion betriff kommplett nicht BAG_WORN")
    end

    self.vars.bagFrom = nil
    self.vars.slotFrom = nil
    self.vars.esFrom = nil
    
    --weiter ausziehen wenn es etwas zum ausziehen giebt
    self:performGearOperations()    
  end
end

function Addon:onEVENT_PLAYER_ACTIVATED(intEventCode, bInitial)
  d("onEVENT_PLAYER_ACTIVATED: "..GetUnitName("player"))
  self:parseInventories()
  deglib(self.libSafe, "setsort")
      
  --self.vars.beforeWeaponPair = self.vars.activeWeaponPair
  --local activeWeaponPair, boolean_locked = GetActiveWeaponPairInfo()
  --self.vars.activeWeaponPair = activeWeaponPair
               
  if self.debug then
    self.savedVariablesChar.gears = {}
    --alles auf anfang
  end               

  --speichere das aktuelle gear                             
  self:saveGear()
end

--#################################################################################################

function Addon:d(m)
  if self.debug then
    _G.d(self.name.."> "..tostring(m))
  end
end

_G[DEG_ADDON.PACKAGE_NAME].plugins[DEG_ADDON.ADDON_NAME_SHORT] = Addon;

EVENT_MANAGER:RegisterForEvent(DEG_ADDON.ADDON_NAME, EVENT_ADD_ON_LOADED, 
  function(event, AddonName)
    if AddonName == _G[DEG_ADDON.PACKAGE_NAME].plugins[DEG_ADDON.ADDON_NAME_SHORT].name then
      _G[DEG_ADDON.PACKAGE_NAME].plugins[DEG_ADDON.ADDON_NAME_SHORT]:Initialize()
      EVENT_MANAGER:UnregisterForEvent(_G[DEG_ADDON.PACKAGE_NAME].plugins[DEG_ADDON.ADDON_NAME_SHORT].name, EVENT_ADD_ON_LOADED)
    end
  end
)